/*
** insert a ROM image into 32768 - 49152 offset into a 128 K rom image
** for PPC55S ethernet boot prom overwrite
*/

#include <stdio.h>
#include <unistd.h>
#include <errno.h>

int
main(int argc, char** argv)
{
    int ac;
    char *target = 0;
    char *insert = 0;
    FILE *fpi = 0;
    FILE *fpo = 0;
    int howmany = 0;
    int c;

#if 0
    while((ac = getopt(argc, argv, "s:e:")) != -1)
    {
    	switch(ac)
	{
	case 's':		/* start address */
	    start = atoi(optarg);
	    break;

	case 'e':		/* end address */
	    end = atoi(optarg);
	    break;
	}
    }

    if(end != -1 && start > end)
    {
    	fprintf(stderr, "start must be less than end address\n");
	exit(1);
    }
#endif

    if(optind + 2 == argc)
    {
    	target = argv[optind++];
    	insert = argv[optind];
    }
    else
    {
	printf("optind = %d\n", optind);
    	fprintf(stderr, "Usage: %s target source\n", argv[0]);
    }

    if(!target)
    {
    	printf("Please specify a target filename\n");
	exit(1);
    }

    if(!insert)
    {
    	printf("Please specify an image filename to insert into %s\n", target);
	exit(1);
    }

    if((fpi = fopen(insert, "r")) == 0)
    {
    	perror(insert);
	exit(1);
    }

    if(fseek(fpi, 0, SEEK_END) == -1)
    {
	perror("fseek(SEEK_END)");
	exit(1);
    }

    if((howmany = ftell(fpi)) != 32768)
    {
    	fprintf(stderr, "Expecting image to insert to be 32K, got %d\n", howmany);
	exit(1);
    }
    rewind(fpi);

    if((fpo = fopen(target, "r+")) == 0)
    {
    	perror(target);
	exit(1);
    }

    if(fseek(fpo, 32768, SEEK_SET) == -1)
    {
	perror("fseek(target)");
	exit(1);
    }

    howmany = 0;
    while((c = fgetc(fpi)) != EOF)
    {
    	if(fputc(c, fpo) == EOF)
	{
	    perror("fputc(target)");
	    exit(1);
	}
	howmany++;
    }

    printf("Inserted %d bytes:\n", howmany);

    fclose(fpi);
    fclose(fpo);
}
