#include <stdio.h>
#include <unistd.h>
#include <errno.h>

int
main(int argc, char** argv)
{
    int ac;
    int start = 0;
    int end = -1;
    char *filename = 0;
    FILE *fpi = 0;
    int c;
    int howmany = 0;

    unsigned short sum = 0;
    unsigned char bytesum = 0;

    unsigned char bytexor = 0;

    while((ac = getopt(argc, argv, "s:e:")) != -1)
    {
    	switch(ac)
	{
	case 's':		/* start address */
	    start = atoi(optarg);
	    break;

	case 'e':		/* end address */
	    end = atoi(optarg);
	    break;
	}
    }

    if(end != -1 && start > end)
    {
    	fprintf(stderr, "start must be less than end address\n");
	exit(1);
    }

    if(optind < argc)
    {
    	filename = argv[optind];
    }

    if(!filename)
    {
    	printf("Please specify a filename\n");
	exit(1);
    }

    if((fpi = fopen(filename, "r")) == 0)
    {
    	perror(filename);
	exit(1);
    }

    if(end == -1)
    {
    	if(fseek(fpi, 0, SEEK_END) == -1)
	{
	    perror("fseek(SEEK_END)");
	    exit(1);
	}
	end = ftell(fpi) - 1;
    }

    rewind(fpi);
    if(start != 0)
    {
    	if(fseek(fpi, start, SEEK_SET) == -1)
	{
	    perror("fseek");
	    exit(1);
	}
    }

    printf("Summing from %X to %x\n", start, end);
    while((c = fgetc(fpi)) != EOF && start <= end)
    {
    	sum += c;
    	bytesum += c;
	bytexor ^= c;
    	start++;
	howmany++;
    }

    printf("Summed %d bytes:\n", howmany);
    printf("\t16 bit checksum = %04X\n", sum);
    printf("\t 8 bit checksum = %02X\n", bytesum);
    printf("\t 8 bit xor = %02X\n", bytexor);

    fclose(fpi);
}
